/*
######################################################################
JS/jQuery for Typesetter CMS plugin Back2Top Button - Admin
Author: J. Krausz
Date: 2018-07-14
Version 1.0.2
######################################################################
*/
/*
window.currentScrollTop = $(window).scrollTop();

$(function(){

  $(".gp_Back2Top").on("click", function() {
    $("html, body").stop().animate({ scrollTop : "0px" }, parseInt(bt2_config.scroll_speed));
  });

  // DETECT PAGE SCROLL AND SHOW B2T BUTTON
  $(window).on("load scroll resize", function(e) {
    if ($(window).scrollTop() > bt2_config.scroll_trigger && window.currentScrollTop <= bt2_config.scroll_trigger) {
      window.currentScrollTop = $(window).scrollTop();
      $(".gp_Back2Top").addClass("b2t-show");
      return;
    }
    if ($(window).scrollTop() < bt2_config.scroll_trigger && window.currentScrollTop >= bt2_config.scroll_trigger) {
      window.currentScrollTop = $(window).scrollTop();
      $(".gp_Back2Top").removeClass("b2t-show");
      return;
    }
  });

});

*/

window.currentScrollTop = window.pageYOffset || document.documentElement.scrollTop;

window.addEventListener("DOMContentLoaded", function() {
  var backToTopButton = document.querySelector(".gp_Back2Top");

  backToTopButton.addEventListener("click", function() {
    scrollToTop(parseInt(bt2_config.scroll_speed));
  });

  window.addEventListener("scroll", function() {
    handleScroll();
  });

  window.addEventListener("resize", function() {
    handleScroll();
  });

  function handleScroll() {
    var scrollTrigger = bt2_config.scroll_trigger;

    if (window.pageYOffset > scrollTrigger && window.currentScrollTop <= scrollTrigger) {
      window.currentScrollTop = window.pageYOffset || document.documentElement.scrollTop;
      backToTopButton.classList.add("b2t-show");
    }

    if (window.pageYOffset < scrollTrigger && window.currentScrollTop >= scrollTrigger) {
      window.currentScrollTop = window.pageYOffset || document.documentElement.scrollTop;
      backToTopButton.classList.remove("b2t-show");
    }
  }

  function scrollToTop(scrollSpeed) {
    var currentPosition = window.pageYOffset || document.documentElement.scrollTop;
    var scrollStep = currentPosition / (scrollSpeed / 15);
    var scrollInterval = setInterval(function() {
      if (currentPosition > 0) {
        currentPosition -= scrollStep;
        window.scrollTo(0, currentPosition);
      } else {
        clearInterval(scrollInterval);
      }
    }, 15);
  }
});
